Page MenuHomePhabricator

Display confirmation message after manual account creation on Wikimedia wikis
Closed, ResolvedPublic

Description

When create a new account on wmf wikis you will automatically redirect to the returnto page.
A success message (welcomecreation-msg) must be shown, so new users will see, that the account is created successfully has worked.

Silent login is okay, but silent signup/account creation is bad.

Fill this in CentralAuth, because it works on my test wiki. But it can also be a config thing.


Version: unspecified
Severity: normal
See Also:
https://bugzilla.wikimedia.org/show_bug.cgi?id=52834

Details

Reference
bz52373

Event Timeline

bzimport raised the priority of this task from to Medium.Nov 22 2014, 2:10 AM
bzimport set Reference to bz52373.

Where are you seeing this issue?

When I go to http://test.wikipedia.org/w/index.php?title=Special:UserLogin&returnto=Main+Page&type=signup and create a new user account, I'm subsequently directed to a welcome screen:


Welcome to Wikipedia, Testing for bug 52373!

Thanks for joining Wikipedia! Here are some ways you can get involved.
Choose an option below, and you will see a random article that needs help.

Improve Clarity
Simplify or reword sentences.

Fix Spelling & Grammar
The easiest way to get started!

Add Links

Connect Wikipedia articles together.

When I go to http://de.wiktionary.org/w/index.php?title=Spezial:Anmelden&returnto=Wiktionary%3AHauptseite&type=signup and create a test account, I am redirected back to the main page.

This may have to do with the GettingStarted extension.

swalling wrote:

(In reply to comment #3)

When I go to
<http://de.wiktionary.org/w/index.php?title=Spezial:
Anmelden&returnto=Wiktionary%3AHauptseite&type=signup>
and create a test account, I am redirected back to the main page.
This may have to do with the GettingStarted extension.

What you're seeing on testwiki is from GettingStarted, but the behavior on German Wiktionary is not. GettingStarted is only installed on enwiki, and the redirect behavior on all other wikis is the expected action from the new version of CentralAuth (aka SUL2).[1] In this case, you're probably being sent back to the Main Page because you don't have a return to destination set. Not all users will be sent to the main page, only those that were already there or who have a null returnto parameter.

Regarding the user experience issue Umherirrender describes: the account creation is not silent. What happens after the user explicitly hits enter or "create your account" is that, regardless of which page they end up on, they are shown as logged in with their desired username and the other items in the personal tools menu. There are also other indicators depending on the wiki -- where there is Echo, there is a welcome notification delivered immediately, and there's also an email confirmation if you sign up with email as many people do.

  1. https://www.mediawiki.org/wiki/Extension:CentralAuth#.22SUL2.22_behavior

(In reply to comment #4)

(In reply to comment #3)

When I go to
http://de.wiktionary.org/w/index.php?title=Spezial:Anmelden&returnto=Wiktionary%3AHauptseite&type=signup
and create a test account, I am redirected back to the main page.
This may have to do with the GettingStarted extension.

What you're seeing on testwiki is from GettingStarted, but the behavior on
German Wiktionary is not.

Sorry, I was a bit ambiguous there. When I said "this may have to do...", I meant this bug, not what the behavior I saw on the German Wiktionary.

GettingStarted is only installed on enwiki [...]

Obviously this isn't the case, given test.wikipedia.org's behavior.

In this case, you're probably being sent back to the Main Page because you
don't have a return to destination set.

Well, no. I'm being sent back to the main page because I clicked "create account" from the main page and my URL does in fact have &returnto=Wiktionary%3AHauptseite in it.

Regarding the user experience issue Umherirrender describes: the account
creation is not silent.

There was previously a welcome screen. This appears to be an unexplained regression.

I have tested this on dewiki without a email given on signup.

swalling wrote:

Regarding the user experience issue Umherirrender describes: the account
creation is not silent.

There was previously a welcome screen. This appears to be an unexplained
regression.

One man's regression is another man's enormous win for sane UX. A more neutral answer is: this was completely intentional in the design and launch of SUL2, and the design team reviewed it and gave an extremely hearty thumbs up. I'm sure Jared or any of the other members of that team would be happy to comment more. My take: unless you're going to actually carry substantive content in a welcome page after account creation on any website (such as a suggested way to get started) there is no need for an entire interstitial page just to confirm you did sign up.

TTO added a comment.Aug 1 2013, 9:31 AM

(In reply to comment #7)

My take: unless you're going to actually carry substantive content in a
welcome page after account creation on any website (such as a suggested way
to
get started)

But this is exactly what a lot of wikis have done. See [[fr:MediaWiki:Welcomecreation-msg]], [[pt:MediaWiki:Welcomecreation-msg]], etc.

Perhaps the solution here is to show an interstitial page only if welcomecreation-msg has been modified (i.e. if the MediaWiki:Welcomecreation-msg page has been created).

(On a side note, if a user provides an e-mail address, they don't seem to get MediaWiki:Welcomecreation-msg. I don't think many wikis have realised this.)

New people, which created a first time a account under mediawiki does not see the different after the signup (the only different for new accounts is the appear of the personal portlet).
In my opinion there must be a success message in the main content area and not a redirect to the previous page.

-jkb- added a comment.Aug 1 2013, 9:41 AM

+1. Pls change this - we have some more (sometimes many ones) registrations on dewiki every day where the new aqccounts are registeres twice. Very irritating. ~~~~

Maybe the following is happen:

  • User is an the main page
  • goes to page "create account"
  • fill in the user name, password, captcha
  • press submit
  • the user get redirected back to main page - the account is created
  • pressed back in browser [because he does not see the different, only personal portlet is now there]
  • refill password (user name and captcha stay there) [page is from cache and does not show a personal portlet]
  • repress submit
  • getting message, that cookies not okay [now the page has a personal porlet]
  • refill password, captcha and fill the reason field (a user on de.wp wrote there, that he has problems with cookies)
  • repress submit
  • Getting message, that the user account already exists
  • Choosing another name
  • resubmit
  • The first account created the second account (you can see that in the logs [1] and [2])

[1] http://de.wikipedia.org/w/index.php?title=Spezial%3ALogbuch&type=newusers&user=Penthesilea7
[2] http://de.wikipedia.org/w/index.php?title=Spezial%3ALogbuch&type=newusers&user=Rhodomont

The summary "Do not automatically redirect after account creation on wmf wikis" does not sound like something that we want, so what's potential options?
Deploy "GettingStarted" also on other wikis?

(In reply to comment #7)

this was completely intentional in the design and launch of SUL2,
and the design team reviewed it and gave an extremely hearty thumbs up.

I wonder whether this statement "only" refers to general login procedure, or explicitly also to the "first time login after account creation" procedure.

swalling wrote:

(In reply to comment #8)

(In reply to comment #7)

My take: unless you're going to actually carry substantive content in a
welcome page after account creation on any website (such as a suggested way
to
get started)

But this is exactly what a lot of wikis have done. See
[[fr:MediaWiki:Welcomecreation-msg]], [[pt:MediaWiki:Welcomecreation-msg]],
etc.
Perhaps the solution here is to show an interstitial page only if
welcomecreation-msg has been modified (i.e. if the
MediaWiki:Welcomecreation-msg page has been created).

I don't think it's "a lot" of wikis. Within the top 10 Wikipedias, for example, it's about half (de, zh, pl, fr) that have overridden MediaWiki:Welcomecreation-msg. But the vast majority of wikis do not have a customized version of the message.

Umherirrender seemed to suggest that this should be a config variable, and I believe it already is.

However, just because a page exists doesn't mean it's better to send people there. I think there's a valid question as to whether it's a better user experience to send people back to what they were doing. Many signups did so in the midst of trying to edit, for instance, and sending them back on their way quickly is important. And these landing pages are all the most beautiful or user-friendly. The Portuguese version seems to be a list of rules, policies and tutorials. The Polish and French versions are trying to help a user create their userpage, but because it's just prefilled templates, it's pretty hacky.

If the UX issue that new users are signing up repeatedly (as the dewiki discussion seems to say?) then we can and should solve that without needing to send all dewiki users through an interstitial landing page. In particular, the roadmap suggests rollout of notifications to more wikis is in the plan for the next couple months.[1]

  1. https://www.mediawiki.org/wiki/Roadmap#Notifications_.28Echo.29

swalling wrote:

(In reply to comment #13)

Umherirrender seemed to suggest that this should be a config variable, and I
believe it already is.
However, just because a page exists doesn't mean it's better to send people
there. I think there's a valid question as to whether it's a better user
experience to send people back to what they were doing. Many signups did so
in
the midst of trying to edit, for instance, and sending them back on their way
quickly is important. And these landing pages are all the most beautiful or
user-friendly. The Portuguese version seems to be a list of rules, policies
and
tutorials. The Polish and French versions are trying to help a user create
their userpage, but because it's just prefilled templates, it's pretty
hacky.

*facepalm*

^ And these landing pages are _not_ all the most beautiful or
user-friendly.

swalling wrote:

*** Bug 52972 has been marked as a duplicate of this bug. ***

usermono wrote:

is it possible to create a custom landing page and let the local wikis choose? Perhaps allow Ext:GettingStarted to be customized locally?

Clarifying subject into "Display confirmation message after manual account creation on WMF wikis". The issue is not the redirect.

It's not clear to me why this extension should be able to suppress the standard confirmation message: only because on one wiki the core feature has been overridden by another extension? The very fact that an extension was developed to do that job seems to confirm that a confirmation message makes sense in core.

Przykuta, was pl.wiki notified, or is it otherwise aware, of this change? It seems you no longer can rely on the confirmation message to avoid the welcome bots, even for the non-autocreated accounts.

swalling wrote:

As an update.(In reply to comment #13)

If the UX issue that new users are signing up repeatedly (as the dewiki
discussion seems to say?) then we can and should solve that without needing
to
send all dewiki users through an interstitial landing page. In particular,
the
roadmap suggests rollout of notifications to more wikis is in the plan for
the
next couple months.[1]

  1. https://www.mediawiki.org/wiki/Roadmap#Notifications_.28Echo.29

Update per the above... Extension:Echo, including the welcome notification post-signup, is now launched on plwiki, ptwiki, and many others.

Using Polish as an example,[1] since Nemo just mentioned them, you can see that the welcome notification is basically being delivered to every new signup per day.[2]

  1. http://ee-dashboard.wmflabs.org/dashboards/plwiki-features
  2. http://ee-dashboard.wmflabs.org/graphs/all_daily_reg

(In reply to comment #18)

Update per the above... Extension:Echo, including the welcome notification
post-signup, is now launched on plwiki, ptwiki, and many others.
Using Polish as an example,[1] since Nemo just mentioned them, you can see
that
the welcome notification is basically being delivered to every new signup per
day.[2]

Good but that's tangential to this CentralAuth bug, which is for all wikis.

(As for the specific pl.wiki example, the Welcome notification has nothing to do with the purpose welcomecreation was used for; but that's something they have to discuss locally.)

I think someone may have suggested this on the EE list. What about showing the welcomecreation message if GettingStarted is not installed and there is a local override of MediaWik:Welcomecreation-msg?

We might also be able to assist with sharing best practices with wikis that haven't done much work here.

Another idea is to only do the above until Echo is installed, since that has a welcome notification of its own.

(In reply to comment #21)

Another idea is to only do the above until Echo is installed, since that has
a
welcome notification of its own.

Yes. Ideally, it would be GettingStarted and Echo (not CentralAuth) disabling a standard feature in core for their own purposes when they are installed and they need to do so.

swalling wrote:

(In reply to comment #20)

I think someone may have suggested this on the EE list. What about showing
the
welcomecreation message if GettingStarted is not installed and there is a
local
override of MediaWik:Welcomecreation-msg?
We might also be able to assist with sharing best practices with wikis that
haven't done much work here.

For documentation, here's what Benoit and I said on the EE list about this:

http://lists.wikimedia.org/pipermail/ee/2013-September/000657.html

To explain it my thinking there some more...

French Wikipedia doesn't have GettingStarted, but is using Welcomecreation-msg to get users to introduce themselves and their interests to the community. That's highly useful, and isn't forcing users through a whole page just to confirm that they registered.

GettingStarted is not the only possible positive experience for a new user post-signup, particularly on a community that isn't Wikipedia (Wiktionary, Commons, and other sister projects probably need something quite different). I do hope to launch GettingStarted on more non-English Wikipedias over the next month or so, but it's not a solution for all wikis by a long shot.

What I am concerned about is that, whatever we present to new users immediately after registration, that it be a reasonably decent design and that it encourages them to get engaged with the wiki. Passive documentation or landing pages with no substantive calls to action are a very poor user experience, particularly for people who realize they did sign up and who are ready to get started with contributing.

I think we need to have a high standard for anything we intend to more or less permanently throw at all users after signup. The default MediaWiki:Welcomecreation-msg isn't up to snuff in any language IMO, but a landing page like what French Wikipedians have made is, even if it's technically not really what that MediaWiki message is for.

Change 86874 had a related patch set uploaded by Anomie:
Add centralauth-welcomecreation-msg

https://gerrit.wikimedia.org/r/86874

(In reply to comment #22)

Yes. Ideally, it would be GettingStarted and Echo (not CentralAuth)
disabling a
standard feature in core for their own purposes when they are installed and
they need to do so.

It's actually not so much CentralAuth disabling the feature as the new flow actually redirects the browser to loginwiki, then back to a CentralAuth special page to finish the login, so we can't run the core bits at that point.

The patch that anomie just put in allows a wiki to set a message like Welcomecreation-msg, for wikis that want to do that.

If we merge that patch, the behavior on WMF sites will remain exactly how it is currently, unless CentralAuth-welcomecreation-msg is defined. In that case, we'll show the message with a link to the returnto parameter. However, GettingStarted (or any extension that implements CentralAuthSilentLoginRedirect hook) can blank out the injected html if they want to just redirect the user to the returnto url instead (or they could change all of the html set by CentralAuth-welcomecreation-msg, if it wanted).

Hopefully that gives everyone the technical means for each site to do what is best for each community.

There's a few concerns I'm trying to balance here.

a) The designers have reviewed some of the messages that were seen by users after account creation, and they're really unhappy with the user experience [1][2]. We want users of Wikimedia wikis to have the best possible experience on the sites.
b) The engineers want to make a piece of software that's flexible and lets people do what they want with it. We don't want to put people in the position where, when they're installing MediaWiki, they have to mess around with MediaWiki's code to get it to do what they want.

On Wikimedia wikis with GettingStarted installed, any other post-creation messages should be overridden. But what about cases where it's not installed? Do we want to be able to let people customise the experience?

I'm CCing in Jared on this so he can give us some feedback. In particular, I'd like him to give his opinion on whether it is worthwhile including in MediaWiki the capability for someone to customise the post-registration experience, or whether he thinks it should be to redirect to the previous page in all cases.

[1] https://pt.wikipedia.org/wiki/MediaWiki:Welcomecreation-msg
[2] https://pl.wikipedia.org/wiki/MediaWiki:Welcomecreation-msg

Thanks everyone for all the lively discussion here.

The design and product teams did a lot of thinking about the onboarding experience when it comes to the new login behavior, so the behavior you're seeing on en.wiki is purposeful, I'm glad we were able to get it implemented, that said sometimes you can only find problems like the ones above once something is in the real world with large numbers of people using it.

My recommendations follow for how to proceed.

New user registration:
Configure welcome echo notification in order to welcome user, and confirm the account was created successfully so that they aren't confused and try to create accounts again.
REQUIRES: echo on more sites, translated echo notifications for new sites

For normal login, users should continue to have the current behavior of being redirected to the page the login action was started from.

Post account creation:
We have a Guided New users experience that the Growth team has created, it represents the first time experience we would like all users to see upon becoming part of the community, in addition to the welcome echo notification new users should be sent to the Guided experience. One additional note is that the echo notification could have a link to go back to the guided experience so if the users leaves it or just wants to try it again they have an additional access point.
REQUIRES: guided new user experience on more wikis

Stopgap measure for wikis who do not have Guided Exp, and Echo implemented:
Until wikis can integrate echo and the guided exp for new users, I would recommend that they have a minimal but *actionable* New user welcome page. If we can identify a best in class example from a wiki who has one already it might be a good pattern to copy.

However I recommend less effort be spent creating this temporary welcome page, rather, focus efforts on getting echo and getting started implemented, as that represents the desired user experience for new users.

(In reply to comment #27)

However I recommend less effort be spent creating this temporary welcome
page,
rather, focus efforts on getting echo and getting started implemented, as
that
represents the desired user experience for new users.

This seems to be what the patch above tries to do. The least effort solution is obviously recycling the welcomecreation-msg used for years; those who don't have them are using welcome bots or NewUserMessage.

Nemo, thank you for clarifying, The en.wiki welcome echo message might be a good place to start as it is very concise.

(In reply to comment #29)

Nemo, thank you for clarifying, The en.wiki welcome echo message might be a
good place to start as it is very concise.

Sure, if we reuse the existing local messages wikis will also be empowered to follow such examples if they wish (but the patch currently use a new message key?).

(In reply to comment #30)

Sure, if we reuse the existing local messages wikis will also be empowered to
follow such examples if they wish (but the patch currently use a new message
key?).

Yes, it does. We thought nothing was preferable to the old message, so using a new, 0-length message let us do that easily.

Jared, if you think the old message is preferable to landing on the original article page (for wikis with no guided tours / echo), then we can update the patch to use the old message. But please clarify.

A new (modeled after en.wiki) welcome message or something similar in tone and length is preferable. Refactoring an existing talk page welcome message as an echo notification is not.

Pointing new users to blank pages would also be antithetical to what we're trying to do with both the new login and new user experiences.

So in order of desirability

New welcome echo message / Direct to getting started after account creation
New welcome echo message / direct to existing site welcome page
New welcome echo message / direct to previous page prior to account creation
Direct to getting started after account creation
direct to existing site welcome page
direct to previous page prior to account creation

swalling wrote:

So in order of desirability
New welcome echo message / Direct to getting started after account creation
New welcome echo message / direct to existing site welcome page
New welcome echo message / direct to previous page prior to account creation
Direct to getting started after account creation
direct to existing site welcome page
direct to previous page prior to account creation

It's the "direct to existing site welcome page" that I have an issue with. Like said above, if you take a look at the existing site welcome page (MediaWiki:Welcomecreation-msg) where it is customized, it's often terrible.

On our wikis many users are currently being redirected back to editable articles. 10% of them (on enwiki, as an example) are even being redirected back directly back to editing. Sending users back to their internal referrer is far superior to these existing site welcome pages.

I'd have to see some examples of ones that you'd consider terrible, to make that call.

Anomie added a comment.Oct 2 2013, 1:34 AM

(In reply to comment #32)

direct to existing site welcome page

Note that it will be trivial for any site to continue to use their pre-SUL2 custom welcome message, all they will need to do is copy MediaWiki:welcomecreation-msg to MediaWiki:centralauth-welcomecreation-msg.

Whether the existing welcome messages are any good is in the end up to each local wiki.

swalling wrote:

(In reply to comment #34)

I'd have to see some examples of ones that you'd consider terrible, to make
that call.

I mentioned a few above. Here are some specific examples:

Even some that look sort of okay present multiple options to new signups, rather than presenting one clear thing for them to do. They also still lean heavily toward the "RTFM" approach to new user engagement which does not work:

It seems to me that well-designed landing pages post-registration are the exception rather than the rule. We've given the "let each community do whatever they want" approach a shot for years with this, and for Wikimedia sites, it has produced lukewarm results at best.

Regardless of the particulars of design for any current landing page out there, we simply must consider the price we pay by forcing users through landing pages post-registration. I have seen no evidence that these landing pages produce better results for new user engagement than simply sending people back to where they were.

On enwiki, for example, a full 9-10% of new signups were in the midst of editing prior to signup. Is it really worth it to distract editors with a landing page? Answering this question is why we have run GettingStarted as an A/B test against the default behavior.

Based on that my recommendation would be:

New welcome echo message / Direct to Getting Started after account creation
New welcome echo message / direct to existing site welcome page
New welcome echo message / direct to previous page prior to account creation
Direct to getting started after account creation
direct to previous page prior to account creation

I think this is in line with your thinking Steven.

/// Correction*

Based on that my recommendation would be:

New welcome echo message / Direct to Getting Started after account creation
New welcome echo message / direct to previous page prior to account creation
Direct to getting started after account creation
direct to previous page prior to account creation

I think this is in line with your thinking Steven.

Change 86874 merged by jenkins-bot:
Add centralauth-welcomecreation-msg

https://gerrit.wikimedia.org/r/86874

TTO added a comment.Nov 18 2013, 11:52 PM

What remains to be done here?

swalling wrote:

(In reply to comment #40)

What remains to be done here?

Nothing, AFAIK. The related patches were merged.